package PreviewTargetChanger::App;

use strict;
use base qw( MT::App::CMS );

sub init_request {
    my $app = shift;
    $app->SUPER::init_request(@_);
    $app->add_methods( remove_preview_file => \&remove_preview_file );

    $app->{ default_mode } = 'main';
    $app->{ requires_login } = 0;
}

# MT::App::CMS::remove_preview_file
sub remove_preview_file {
    my $app = shift;

    my $blog_id = $app->param('blog_id');
    return if !$blog_id;

    my $blog = MT::Blog->load( $blog_id );
    return if !$blog;

    my $preview_basename = $app->param('_preview_file');

    if ($preview_basename) {
        require MT::Session;
        if (my $tf = MT::Session->load(
                {   id   => $preview_basename,
                    kind => 'TF',
                }
            )
            )
        {
            my $file = $tf->name;
            my $fmgr = $blog->file_mgr;
            $fmgr->delete($file);
            $tf->remove;
        }
    }
}

1;
