package PreviewTargetChanger::CMS;
use strict;

sub init_request {
    my ($eh, $app) = @_;
    $app->config( 'PreviewInNewWindow', 0 );
}

sub set_param {
    my ($cb, $app, $param, $tmpl) = @_;
    $param->{cgi_path} = MT->config->CGIPath;
    $param->{preview_url} = $param->{preview_url} . '?' . time();
}

sub preview_entry {
    my ($cb, $app, $tmpl) = @_;

    # 0:load end/1:close button
    my $plugin = MT->component("PreviewTargetChanger");
    my $timing = $plugin->get_config_value('timing', 'blog:'.$app->blog->id);

    my $blog_id = $app->param('blog_id');

    my $old;
    my $new;

    if ( $timing ) {
        $old = <<HERE;
  </head>
HERE
        $old = quotemeta($old);

        $new = <<HERE;
<style type="text/css">
#brand a, .preview-screen #brand {
	display: none;
}
.preview-screen #entry-preview-control-strip, .preview-screen #template-preview-control-strip {
	display: none;
}
.no_display {
    display:none;
}
</style>
  </head>
HERE

        $$tmpl =~ s/$old/$new/;
    }

    $old = <<HERE;
    <table id="entry-preview-layout" class="preview-layout">
      <tr>
HERE
    $old = quotemeta($old);

    $new = <<HERE;
<script>
var plugin_cgi_path = '<mt:var name="cgi_path">plugins/PreviewTargetChanger/mt-remove.cgi';
var blog_id = '$blog_id';
var delete_preview_file = function() {
    jQuery.ajax({
        url: plugin_cgi_path,
        data: {
            'blog_id': blog_id,
            '__mode': 'remove_preview_file',
            '_preview_file': jQuery('input[name=_preview_file]').val()
        },
        type: 'POST',
    })
    .done(function( data, status, xhr ) {
    })
    .fail(function( data, status, xhr ) {
        alert( status );
    })
    .always(function( data ) {
HERE

    if ( !$timing ) {
        $new .= <<HERE;
        window.close();
HERE
}

        $new .= <<HERE;
    });
};
jQuery(function(){
HERE

    if ( $timing ) {
        $new .= <<HERE;
    delete_preview_file();
HERE
    } else {
        $new .= <<HERE;
    url = '<mt:var name="cgi_path">' + 'mt-static/plugins/PreviewTargetChanger/images/ajax-loader.gif'
    jQuery('#close').click(function(e){
jQuery('body').css('background', 'url(' +  url + ') fixed center no-repeat');
jQuery('body').css('opacity','0.4');
        delete_preview_file();
        return false;
    });
HERE
    }

    $new .= <<HERE;
});
</script>
HERE

    if ( $timing ) {
        $new .= <<HERE;
    <table id="entry-preview-layout" class="preview-layout">
      <tr class="no_display">
HERE
    } else {
    $new .= <<HERE;
    <table id="entry-preview-layout" class="preview-layout">
      <tr class>
HERE
    }

    $$tmpl =~ s/$old/$new/;

    if ( !$timing ) {
        my $close_button_title = $plugin->translate('Close');

        $old = <<HERE;
  <button
     mt:mode="save_entry"
     type="submit"
     name="save"
     value="save"
     accesskey="s"
     title="<\$mt:var name="save_button_title"\$>"
     class="save action primary button">
    <mt:var name="save_button_value">
  </button>
  <button
     mt:mode="view"
     type="submit"
     name="reedit"
     value="reedit"
     accesskey="e"
     title="<\$mt:var name="edit_button_title"\$>"
     class="action button">
    <mt:var name="edit_button_value">
  </button>
HERE
        $old = quotemeta($old);

        $new = <<HERE;
  <button
     id="close"
     class="action button">
    $close_button_title
  </button>
HERE
        $$tmpl =~ s/$old/$new/;
    }
}

sub edit_entry {
    my ($cb, $app, $tmpl) = @_;

    my $plugin = MT->component("PreviewTargetChanger");
    my $target = $plugin->get_config_value('entry_target', 'blog:'.$app->blog->id);
    my $diff = $plugin->get_config_value('diff_entry', 'blog:'.$app->blog->id);

    my $old = <<HERE;
<mt:include name="include/header.tmpl" id="header_include">
HERE
    $old = quotemeta($old);

    my $new = <<HERE;
<mt:include name="include/header.tmpl" id="header_include">
<script type="text/javascript">
function preview_with_new_window(f) {
    jQuery('form#entry_form').attr("onsubmit","return false");
    jQuery('form#entry_form').removeAttr("mt:once");
    jQuery('form#entry_form input[name=__mode]').val('preview_entry');
    jQuery('form#entry_form > input[name=status]').val(100);
HERE

    if ($diff) {
        $new .= <<HERE;
    var date = new Date();
    f.target = "mtentrypreview" + date.getTime();
HERE
    } else {
        $new .= <<HERE;
    f.target = "mtentrypreview";
HERE
    }

    if($target){
        my $width = $plugin->get_config_value('width', 'blog:'.$app->blog->id);
        my $height = $plugin->get_config_value('height', 'blog:'.$app->blog->id);

        $new .= <<HERE;
    var w = window.open("about:blank", f.target, 'width=$width, height=$height, location=no');
    w.focus();
HERE
    }

    $new .= <<HERE;
    f.submit();
}
</script>
HERE

    $$tmpl =~ s/$old/$new/;

    $old = <<HERE;
    <div class="preview-action">
      <button
         name="preview_entry"
         type="submit"
         accesskey="v"
         title="<mt:var name="preview_button_title">"
         class="preview action button">
        <__trans phrase="Preview">
      </button>
    </div>
HERE
    $old = quotemeta($old);

    $new = <<HERE;
    <div class="preview-action">
      <button
         name="preview_entry"
         type="submit"
         accesskey="v"
         title="<mt:var name="preview_button_title">"
         onclick="preview_with_new_window(this.form)"
         class="preview action button">
        <__trans phrase="Preview">
      </button>
    </div>
HERE

    $$tmpl =~ s/$old/$new/;

    $old = <<HERE;
    jQuery('button.preview').click(function(event) {
        jQuery('form#entry_form input[name=__mode]').val('preview_entry');
  <mt:if name="config.previewinnewwindow">
        jQuery('form#entry_form').attr('target', '_brank');
  </mt:if>
    });
HERE
    $old = quotemeta($old);

    $$tmpl =~ s/$old//;

    $old = <<HERE;
  <mt:if name="config.previewinnewwindow">
    jQuery('button.publish').click(function(event) {
        app.clearDirty();
        app.stopAutoSave();
        jQuery('form#entry_form input[name=__mode]').val('save_entry');
        jQuery('form#entry_form').removeAttr('target');
        jQuery(this).attr('disabled', 'disabled');
        jQuery('form#entry_form').submit();
    });
  </mt:if>
HERE
    $old = quotemeta($old);

    $new = <<HERE;
    jQuery('button.publish').click(function(event) {
        app.clearDirty();
        app.stopAutoSave();
        jQuery('form#entry_form input[name=__mode]').val('save_entry');
        jQuery('form#entry_form').removeAttr('target');
        jQuery('form#entry_form').removeAttr("onsubmit");
        jQuery(this).attr('disabled', 'disabled');
        jQuery('form#entry_form').submit();
    });
HERE

    $$tmpl =~ s/$old/$new/;

    # for MT5.2
    $old = <<HERE;
    jQuery('select#status').change( setSaveButtonText );
HERE
    $old = quotemeta($old);

    $new = <<HERE;
    jQuery('select#status').change( setSaveButtonText );

    jQuery('button.publish').click(function(event) {
        jQuery('form#entry_form input[name=__mode]').val('save_entry');
        jQuery('form#entry_form').removeAttr("onsubmit");
        jQuery('form#entry_form').removeAttr("target");
    });
HERE

    $$tmpl =~ s/$old/$new/;

}

sub preview_template {
    my ($cb, $app, $tmpl) = @_;

    # 0:load end/1:close button
    my $plugin = MT->component("PreviewTargetChanger");
    my $timing = $plugin->get_config_value('timing', 'blog:'.$app->blog->id);

    my $blog_id = $app->param('blog_id');

    my $old;
    my $new;

    if ( $timing ) {
        my $old = <<HERE;
</head>
HERE
        $old = quotemeta($old);

        $new = <<HERE;
<style type="text/css">
#brand a, .preview-screen #brand {
	display: none;
}
.preview-screen #entry-preview-control-strip, .preview-screen #template-preview-control-strip {
	display: none;
}
.no_display {
    display:none;
}
</style>
</head>
HERE
        $$tmpl =~ s/$old/$new/;
    }

    $old = <<HERE;
    <table id="template-preview-layout" class="preview-layout">
      <tr>
HERE
    $old = quotemeta($old);

    $new = <<HERE;
<script>
var plugin_cgi_path = '<mt:var name="cgi_path">plugins/PreviewTargetChanger/mt-remove.cgi';
var blog_id = '$blog_id';
var delete_preview_file = function() {
    jQuery.ajax({
        url: plugin_cgi_path,
        data: {
            'blog_id': blog_id,
            '__mode': 'remove_preview_file',
            '_preview_file': jQuery('input[name=_preview_file]').val()
        },
        type: 'POST',
    })
    .done(function( data, status, xhr ) {
    })
    .fail(function( data, status, xhr ) {
        alert( status );
    })
    .always(function( data ) {
HERE

    if ( !$timing ) {
        $new .= <<HERE;
        window.close();
HERE
    }

        $new .= <<HERE;
    });
};
jQuery(function(){
HERE

    if ( $timing ) {
        $new .= <<HERE;
    delete_preview_file();
HERE
    } else {
        $new .= <<HERE;
    url = '<mt:var name="cgi_path">' + 'mt-static/plugins/PreviewTargetChanger/images/ajax-loader.gif'
    jQuery('#close').click(function(e){
    jQuery('body').css('background', 'url(' +  url + ') fixed center no-repeat');
    jQuery('body').css('opacity','0.4');
        delete_preview_file();
        return false;
    });
HERE
    }

    $new .= <<HERE;
});
</script>
HERE

    if ( $timing ) {
        $new .= <<HERE;
    <table id="template-preview-layout" class="preview-layout">
      <tr class="no_display">
HERE
    } else {
        $new .= <<HERE;
    <table id="template-preview-layout" class="preview-layout">
      <tr class>
HERE
    }

    $$tmpl =~ s/$old/$new/;

    if ( !$timing ) {
        my $close_button_title = $plugin->translate('Close');

        $old = <<HERE;
  <button
     mt:mode="save"
     type="submit"
     name="save"
     value="save"
     accesskey="s"
     title="<__trans phrase="Save this template (s)">"
     class="save action primary button">
    <__trans phrase="Save this template">
  </button>
  <button
     mt:mode="view"
     type="submit"
     name="reedit"
     value="reedit"
     accesskey="e"
     title="<__trans phrase="Re-Edit this template (e)">"
     class="action button">
    <__trans phrase="Re-Edit this template">
  </button>
HERE
        $old = quotemeta($old);

        $new = <<HERE;
  <button
     id="close"
     class="action button">
    $close_button_title
  </button>
HERE
        $$tmpl =~ s/$old/$new/;
    }
}

sub edit_template {
    my ($cb, $app, $tmpl) = @_;

    my $plugin = MT->component("PreviewTargetChanger");
    my $target = $plugin->get_config_value('template_target', 'blog:'.$app->blog->id);
    my $diff = $plugin->get_config_value('diff_template', 'blog:'.$app->blog->id);

    my $old = <<HERE;
<mt:include name="include/header.tmpl" id="header_include">
HERE
    $old = quotemeta($old);

    my $new = <<HERE;
<mt:include name="include/header.tmpl" id="header_include">
<script type="text/javascript">
function preview_with_new_window(f) {
    jQuery('form#template-listing-form').attr("onsubmit","return false");
    jQuery('form#template-listing-form').removeAttr("mt:once");
    jQuery('form#template-listing-form input[name=__mode]').val('preview_template');
HERE

    # for MT5.2
    my $old = <<HERE;
<mt:include name="include/header.tmpl">
HERE
    $old = quotemeta($old);

    my $new = <<HERE;
<mt:include name="include/header.tmpl">
<script type="text/javascript">
function preview_with_new_window(f) {
    jQuery('form#template-listing-form').attr("onsubmit","return false");
    jQuery('form#template-listing-form').removeAttr("mt:once");
    jQuery('form#template-listing-form input[name=__mode]').val('preview_template');
HERE

    if ($diff) {
        $new .= <<HERE;
    var date = new Date();
    f.target = "mttemplatepreview" + date.getTime();
HERE
    } else {
        $new .= <<HERE;
    f.target = "mttemplatepreview";
HERE
    }

    if($target){
        my $width = $plugin->get_config_value('width', 'blog:'.$app->blog->id);
        my $height = $plugin->get_config_value('height', 'blog:'.$app->blog->id);

        $new .= <<HERE;
    var w = window.open("about:blank", f.target, 'width=$width, height=$height, location=no');
    w.focus();
HERE
    }

    $new .= <<HERE;
    f.submit();
}
</script>
HERE
    $$tmpl =~ s/$old/$new/;

    $old = <<HERE;
  <button
     name="preview_template"
HERE
    $old = quotemeta($old);

    $new = <<HERE;
  <button
     onclick="preview_with_new_window(this.form)"
     name="preview_template"
HERE

    $$tmpl =~ s/$old/$new/;

    $old = <<HERE;
    jQuery('button.save, button.publish').click(function() {
HERE
    $old = quotemeta($old);

    $new = <<HERE;
    jQuery('button.save, button.publish').click(function() {
        jQuery('form#template-listing-form').removeAttr("onsubmit");
        jQuery('form#template-listing-form').attr("target","_self");
HERE

    $$tmpl =~ s/$old/$new/;

    $old = <<HERE;
    jQuery('button.preview').click(function() {
HERE
    $old = quotemeta($old);

    $new = <<HERE;
    jQuery('button.preview').click(function() {
        jQuery('form#template-listing-form').attr("onsubmit","return false");
        jQuery('form#template-listing-form').removeAttr("mt:once");
HERE

    $$tmpl =~ s/$old/$new/;
}

1;
